﻿using Extensibility;
using MediaCy.IQL.Application;
using System;

namespace $safeprojectname$
{
    public class Addin : Extensibility.IDTExtensibility2, IRibbonExtensibility
    {
        private McApplication _application;

        #region "IDTExtensibility2 Implementation"

        void IDTExtensibility2.OnAddInsUpdate(ref Array custom) {}
        void IDTExtensibility2.OnBeginShutdown(ref Array custom) {}
        void IDTExtensibility2.OnStartupComplete(ref Array custom) {}

        void IDTExtensibility2.OnConnection(object Application, ext_ConnectMode ConnectMode, object AddInInst, ref Array custom)
        {
            _application = (McApplication)Application;
            _application.AfterInitialize += _application_AfterInitialize;
            _application.BeforeShutdown += _application_BeforeShutdown;
            _application.SelectedDataChanged += _application_SelectedDataChanged;
        }

        void IDTExtensibility2.OnDisconnection(ext_DisconnectMode RemoveMode, ref Array custom)
        {
            _application = null;
        }

        #endregion

        #region "IRibbonExtensibility Implementation"

        string IRibbonExtensibility.GetCustomUI(string RibbonID)
        {
            return global::$safeprojectname$.Properties.Resources.$safeprojectname$;
        }
        
        public object GetImage(string image)
        {
            return global::$safeprojectname$.Properties.Resources.ResourceManager.GetObject(image);
        }

        #endregion

        /// <summary>
        /// Handles document activation in the application.
        /// </summary>
        /// <param name="Flags"></param>
        void _application_SelectedDataChanged(IMcData.DataTypes Flags)
        {
        }

        /// <summary>
        /// Handles shutdown to save modified data.
        /// </summary>
        /// <param name="Cancel"></param>
        void _application_BeforeShutdown(ref bool Cancel)
        {
        }

        /// <summary>
        /// Handles application initialization at the end of startup.
        /// </summary>
        /// <param name="Starting"></param>
        void _application_AfterInitialize(bool Starting)
        {
        }
    }
}
